package main

import (
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/commissionCC/function"
)

func NewChaincode() *chaincode.CommonChaincode {

	// invoke

	chaincode.ChaincodeVar.Actions[invoke.AddCommissionFunction] = function.AddCommission
	chaincode.ChaincodeVar.Actions[invoke.UpdateCommissionFunction] = function.UpdateCommission

	// query

	chaincode.ChaincodeVar.Actions[invoke.GetCommissionFunction] = function.GetCommission

	chaincode.ChaincodeVar.Actions[invoke.ClearLedger] = function.ClearLedger

	return &chaincode.ChaincodeVar
}
