package function

import (
	"encoding/json"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/commissionCC/mngr"
	"gitlab.smartblocklab.com/smartcontracts/common/model/commissionCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

func GetCommission(userParameter *requests.Parameter, systemParameter *requests.Parameter, manager chaincode.IManager) (interface{}, error) {
	var getCommissionArg commissionCC.GetCommissionArg
	err := json.Unmarshal(systemParameter.Param, &getCommissionArg)
	if err != nil {
		return nil, errors.Errorf("Wasn't able to read GetCommissionArg passed as parameter, due to %s", err)
	}

	return mngr.GetCommissionManager(manager).GetCommission(getCommissionArg)
}
