package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/commissionCC"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

func (this *CommissionManagerImpl) UpdateCommission(commission *commissionCC.Commission, systemParameterUserID string) (*commissionCC.Commission, error) {
	systemUser, err := this.UserCC.GetUser(&requests.Id{Id: systemParameterUserID})
	if err != nil {
		return nil, errors.Errorf("Can't load user by systemParameter.UserID. Error %s", systemParameterUserID, err)
	}

	if commission.PartnerCode != systemUser.PartnerCode {
		return nil, errors.Errorf("Can't addCommission because systemUser.PartnerCode %s is not equals with commission.PartnerCode %s", systemUser.PartnerCode, commission.PartnerCode)
	}

	validObject, err := this.UpdateObject(commission)
	if err != nil {
		return nil, err
	}
	return commissionCC.Cast(validObject)
}
