package isystempreference

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/preferenceCC"
)

type ISystemPreferenceManager interface {
	// invoke
	AddPreference(preference *preferenceCC.Preference) (*preferenceCC.Preference, error)
	UpdatePreference(preference *preferenceCC.Preference) (*preferenceCC.Preference, error)
	// query
	GetPreference(key *requests.Id) (*preferenceCC.Preference, error)
	GetPreferenceArrayByKeysWithFilter(keysWithFilter *requests.KeysWithFilter) (*preferenceCC.PreferenceArray, error)
}
