package systempreferenceCC

import (
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type FieldConstraint struct {
	Field   string `json:"field"`
	Pattern string `json:"pattern"`
}

type FieldConstraintsList struct {
	Constraints []FieldConstraint `json:"constraints"`
}

func (this FieldConstraintsList) GetObjectType() string  {
	return "FieldConstraintsList";
}

func (this FieldConstraintsList) New() chaincode.ValidObject {
	return &FieldConstraintsList{}
}

func (this FieldConstraintsList) CheckBeforeAdd(manager chaincode.IManager) error {
	return nil
}

func (this FieldConstraintsList) CheckBeforeUpdate(updatedObject chaincode.ValidObject, manager chaincode.IManager) error {
	return nil
}

func (this FieldConstraintsList) GetKey(manager chaincode.IManager) []string {
	return []string{FieldConstraintsKey}
}

func (this FieldConstraintsList) Validate() error {
	if len(this.Constraints) == 0 {
		return errors.New("Constraints is empty")
	}

	for _, v := range this.Constraints {
		if len(v.Field) == 0 {
			return errors.New("Field is empty")
		}
		if len(v.Pattern) == 0 {
			return errors.New("Pattern is empty")
		}
	}

	return nil
}
